# CSV_Export_Plugin
# Initial code generated by Softimage SDK Wizard
# Executed Mon May 12 18:07:14 UTC+0200 2014 by 3d1-7p64
# 
# Tip: To add a command to this plug-in, right-click in the 
# script editor and choose Tools > Add Command.
import win32com.client
from win32com.client import constants as c
import csv
from siutils import si      # Application
from siutils import sidict  # Dictionary
from siutils import log     # LogMessage
xsi = Application
c.siMsgYesNoCancel
c.siMsgOk
c.siMsgOkOnly

null = None
false = 0
true = 1

def XSILoadPlugin( in_reg ):
	in_reg.Author = "Jan Dubied"
	in_reg.Name = "CSV_Export_Plugin"
	in_reg.Major = 1
	in_reg.Minor = 0

	in_reg.RegisterProperty("CSV_Export_Plugin")
	in_reg.RegisterMenu(c.siMenuMainFileExportID,"CSV_Export_Plugin_Menu",false,false)	
	
	#RegistrationInsertionPoint - do not remove this line

	return true

def XSIUnloadPlugin( in_reg ):
	strPluginName = in_reg.Name
	Application.LogMessage(str(strPluginName) + str(" has been unloaded."),c.siVerbose)
	return true

def CSV_Export_Plugin_OnInit( ):
	Application.LogMessage("CSV_Export_Plugin_OnInit called",c.siVerbose)
	return true
	
def CSV_Export_Plugin_Menu_Init( in_ctxt ):
	oMenu = in_ctxt.Source
	oMenu.AddCallbackItem("CSV_Export_Plugin","OnCSV_Export_Plugin_MenuClicked")
	return true
	
def OnCSV_Export_Plugin_MenuClicked( in_ctxt ):
	Application.SelectObj("Scene_Root", "", "")
	Application.AddProp("CSV_Export_Plugin")
	Application.DeselectAll()
	return 1
	
def CSV_Export_Plugin_Define( in_ctxt ):
	oCustomProperty = in_ctxt.Source
	oCustomProperty.AddParameter2("CustomStartFrame",c.siInt2,1,0,25000,0,250,c.siClassifUnknown,c.siPersistable, "Start Frame")
	oCustomProperty.AddParameter2("CustomEndFrame",c.siInt2,100,0,25000,0,250,c.siClassifUnknown,c.siPersistable, "End Frame")
	oCustomProperty.AddParameter2("Filename", c.siString, "pointcloud")
	oCustomProperty.AddParameter2("FileEnding", c.siString, "csv")
	oCustomProperty.AddParameter2("SavePath", c.siString, str(Application.ActiveProject2.Path) + "\Simulation")
	oCustomProperty.AddParameter2("doRound",c.siBool,true,null,null,null,null,c.siClassifUnknown,c.siPersistable, "Do Round")
	oCustomProperty.AddParameter2("rounder",c.siInt2,1000,0,25000,0,250,c.siClassifUnknown,c.siPersistable, "Round to")
	oCustomProperty.AddParameter2("ExpPos",c.siBool,true,null,null,null,null,c.siClassifUnknown,c.siPersistable, "Position")
	oCustomProperty.AddParameter2("ExpSiz",c.siBool,true,null,null,null,null,c.siClassifUnknown,c.siPersistable, "Size")
	oCustomProperty.AddParameter2("ExpScl",c.siBool,true,null,null,null,null,c.siClassifUnknown,c.siPersistable, "Scale")
	oCustomProperty.AddParameter2("ExpRot",c.siBool,true,null,null,null,null,c.siClassifUnknown,c.siPersistable, "Rotation")
	oCustomProperty.AddParameter2("ExpVel",c.siBool,true,null,null,null,null,c.siClassifUnknown,c.siPersistable, "Velocity")
	oCustomProperty.AddParameter2("ExpCol",c.siBool,true,null,null,null,null,c.siClassifUnknown,c.siPersistable, "Color")
	oCustomProperty.AddParameter2("Expid",c.siBool,true,null,null,null,null,c.siClassifUnknown,c.siPersistable, "ID")


def CSV_Export_Plugin_DefineLayout( in_ctxt ):	
	oLayout = in_ctxt.Source
	oLayout.Clear()
	oLayout.Language = "Python"
	oLayout.AddGroup("Frame Range")
	oLayout.AddItem("CustomStartFrame")
	oLayout.AddItem("CustomEndFrame")
	oLayout.EndGroup()
	oLayout.AddGroup("File Output")
	oLayout.AddItem("FileEnding")	
	oLayout.AddItem("Filename")
	oLayout.AddItem("SavePath", "Folder Path", c.siControlFolder)		#	oLayout.AddItem("dPath", siControlFolder, "Folder")
	oLayout.EndGroup()
	oLayout.AddGroup("Export Parameter")
	oLayout.AddItem("ExpPos")
	oLayout.AddItem("ExpSiz")
	oLayout.AddItem("ExpScl")
	oLayout.AddItem("ExpRot")
	oLayout.AddItem("ExpVel")
	oLayout.AddItem("ExpCol")
	oLayout.AddItem("Expid")
	oLayout.EndGroup()
#	oLayout.AddItem("doRound")
	oLayout.AddItem("rounder")
	oLayout.AddGroup("")
	oLayout.AddRow()
	oLayout.AddGroup('',false, 10)
	oLayout.EndGroup()
	oLayout.AddGroup('',false, 40)
	oButtonE = oLayout.AddButton( "Export" )
	oButtonE.SetAttribute (c.siUIContinue, true)
	oButtonE.SetAttribute(c.siUICX, 150)
	oButtonE.SetAttribute(c.siUICY, 40)
	oLayout.EndGroup()
	oLayout.AddGroup('',false, 10)
	oLayout.EndGroup()
	oLayout.EndRow()
#	oLayout.AddButton("Export")
	oLayout.EndGroup()
	
def CSV_Export_Plugin_Export_OnClicked( ):	# here's the magic
	#Application.LogMessage("CSV_Export_Plugin_Export_OnClicked called",c.siVerbose)
	oObj = Application.Selection(0)
	current = xsi.GetValue("PlayControl.Current")
	Fc = int(float(current))
	collSel = xsi.Selection

	if collSel.Count == 1:
		if collSel(0).Type == "pointcloud":
			oPBar = XSIUIToolkit.ProgressBar
			oPBar.Maximum = PPG.CustomEndFrame.Value
			oPBar.Caption = "Exporting Frames to " + str(PPG.SavePath) + " from " + str(PPG.Filename)
			oPBar.CancelEnabled = False #I consider a cancel option when dealing with external tools/scripts unsafe in general, up to you what to do here.
			oPBar.Visible = True

#	if Application.Selection(0):
	if collSel.Count == 1:
		if collSel(0).Type == "pointcloud":

			for Fc in range( int(PPG.CustomStartFrame) , int(PPG.CustomEndFrame) + 1):

				# Get a CSV writer object
				# http://docs.python.org/release/2.5.2/lib/module-csv.html
				Application.SetValue("PlayControl.Current", Fc, "")
				csvWriter = csv.writer(open(str(PPG.SavePath) + '/' + str(PPG.Filename) + '_' + str(Fc) + '.' + str(PPG.FileEnding), 'wb'), delimiter=',', quotechar='|', quoting=csv.QUOTE_MINIMAL)
				
				oPBar.Increment()				
				# Use the ICEAttribute.DataArray for PointPositions
				# For large point clouds, use ICEAttribute.GetDataArrayChunk
				
				# if PPG.ExpPos == true:
				# Position
				points = sidict.GetObject( oObj ).ActivePrimitive.Geometry.ICEAttributes("PointPosition").DataArray
				for p in points:
				#	log( "%s, %s, %s" % (round(p.X*int(PPG.rounder))/int(PPG.rounder), round(p.Y*int(PPG.rounder))/int(PPG.rounder), round(p.Z*int(PPG.rounder))/int(PPG.rounder)) )
					if PPG.ExpPos.value == True:
						csvWriter.writerow([round(p.X*int(PPG.rounder))/int(PPG.rounder), round(p.Y*int(PPG.rounder))/int(PPG.rounder), round(p.Z*int(PPG.rounder))/int(PPG.rounder)])
					#	print PPG.ExpPos
					#	print "if"
					#else:
					#	print PPG.ExpPos
					#	print "else"
				# Size
				sizis = sidict.GetObject( oObj ).ActivePrimitive.Geometry.ICEAttributes("Size").DataArray
				for s in sizis:
					if PPG.ExpSiz.value == True:
						csvWriter.writerow([round(s*int(PPG.rounder))/int(PPG.rounder)])			
				# Scale
				sclis = sidict.GetObject( oObj ).ActivePrimitive.Geometry.ICEAttributes("Scale").DataArray
				for x in sclis:
					if PPG.ExpScl.value == True:
						csvWriter.writerow([round(x.X*int(PPG.rounder))/int(PPG.rounder), round(x.Y*int(PPG.rounder))/int(PPG.rounder), round(x.Z*int(PPG.rounder))/int(PPG.rounder)])
				# Rotation
				rotis = sidict.GetObject( oObj ).ActivePrimitive.Geometry.ICEAttributes("Orientation").DataArray
				for r in rotis:
					if PPG.ExpRot.value == True:
						csvWriter.writerow([round(r.RotX*int(PPG.rounder))/int(PPG.rounder), round(r.RotY*int(PPG.rounder))/int(PPG.rounder), round(r.RotZ*int(PPG.rounder))/int(PPG.rounder)])
				# Velocity
				velis = sidict.GetObject( oObj ).ActivePrimitive.Geometry.ICEAttributes("PointVelocity").DataArray
				for v in velis:
					if PPG.ExpVel.value == True:
						csvWriter.writerow([round(v.X*int(PPG.rounder))/int(PPG.rounder), round(v.Y*int(PPG.rounder))/int(PPG.rounder), round(v.Z*int(PPG.rounder))/int(PPG.rounder)])
				# Color
				colis = sidict.GetObject( oObj ).ActivePrimitive.Geometry.ICEAttributes("Color").DataArray
				for c in colis:
					if PPG.ExpCol.value == True:
						csvWriter.writerow([round(c.Red*int(PPG.rounder))/int(PPG.rounder), round(c.Green*int(PPG.rounder))/int(PPG.rounder), round(c.Blue*int(PPG.rounder))/int(PPG.rounder), round(c.Alpha*int(PPG.rounder))/int(PPG.rounder)])
				# ID
				idis = sidict.GetObject( oObj ).ActivePrimitive.Geometry.ICEAttributes("ID").DataArray
				for i in idis:
					if PPG.Expid.value == True:
						csvWriter.writerow([i])

					
	#			elif PPG.ExpSiz == true:
	#				print "elif"

	#			else:
				
	#				print "else"
	#				print PPG.ExpPos
				
	#			print '"' + str(oObj) + '"' + ' Attributes are Exported'
		else:
			print "please select a pointcloud"
			response = XSIUIToolkit.MsgBox("Please Select a Pointcloud", 0 , "Selection Error") 
	#		if response == c.siMsgOk:
	#			print "Do something"
	else:
		print "please select a pointcloud"
		response = XSIUIToolkit.MsgBox("Please Select a Pointcloud", 0 , "Selection Error") 